/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 **************************************************************************/
package com.adobe.cq.editor.model.asset.mapping;

import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;

import javax.annotation.PostConstruct;
import javax.inject.Inject;

import com.day.cq.i18n.I18n;
import com.day.cq.wcm.api.components.Component;
import com.day.cq.wcm.api.components.ComponentEditConfig;
import com.day.cq.wcm.api.components.ComponentManager;
import com.day.cq.wcm.api.components.DropTarget;
import org.apache.commons.lang.StringUtils;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.request.RequestParameter;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ValueMap;
import org.apache.sling.commons.json.JSONArray;
import org.apache.sling.commons.json.JSONException;
import org.apache.sling.commons.json.JSONObject;
import org.apache.sling.commons.json.io.JSONWriter;
import org.apache.sling.models.annotations.Model;
import org.apache.sling.models.annotations.injectorspecific.Self;

/**
 * Represents the whole configuration of mappings from assets to components
 */
@Model(adaptables = SlingHttpServletRequest.class)
public final class AssetToComponentMap {

    private static final String ASSET_TO_COMPONENT_MAPPING_PATH = "cq:authoring/assetToComponentMapping";
    private static final String POLICY_RESOURCE_TYPE = "wcm/core/components/policy/policy";
    private static final String POLICY_RESOURCE_TYPE_PROPERTY = "policyResourceType";
    private static final String POLICY_DIRECTORY_RELATIVE_PATH = "settings/wcm/policies/";

    @Self
    private SlingHttpServletRequest slingRequest;

    @Inject
    private ResourceResolver resourceResolver;

    private SortedMap<String, ComponentDropTarget> componentDropTargets = new TreeMap<String, ComponentDropTarget>();

    private List<AssetToComponentMapping> mappings = new ArrayList<AssetToComponentMapping>();

    private Resource componentResource;

    private I18n i18n;

    @PostConstruct
    protected void initModel() {
	}

    /**
     * Extracts the component resource type from the policy path
     *
     * Policy path: policyDirectory/componentResourceType/policyName
     *
     * @param path
     * @param resourceName
     * @return
     */
    private String getPolicyComponentPath(String path, String resourceName) {
		return null;
	}

    private List<ComponentDropTarget> getSelectableDropTargets() {
		return null;
	}

    private void initComponentDropTargets(Collection<Component> components) {
	}

    /**
     * Returns the list of all the {@link AssetToComponentMapping}s
     *
     * @return
     */
    public List<AssetToComponentMapping> getMappings() {
		return null;
	}

    /**
     * Returns the formatted data gathering the exhaustive list of component drop targets
     *
     * @return
     * @throws JSONException
     */
    public String getComponentDropTargetsData() throws JSONException {
		return null;
	}
}
