/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ************************************************************************/
package com.adobe.cq.screens.device;

import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;

import aQute.bnd.annotation.ProviderType;

import org.apache.sling.api.adapter.Adaptable;

/**
 * Screens devices. Is adaptable to and from a resource, and to a value map to get its properties.
 */
@ProviderType
public interface Device extends Adaptable {

    /**
     * Returns the path of the device resource.
     * @return the path
     */
    @Nonnull
    String getPath() {
		return null;
	}

    /**
     * Returns the id of the device.
     * @return the id
     */
    @Nonnull
    String getId() {
		return null;
	}

    /**
     * Returns the device config or {@code null} if not assigned.
     * @return the config or {@code null}
     */
    @CheckForNull
    DeviceConfig getDeviceConfig() {
		return null;
	}

    /**
     * Returns a Boolean depending on whether the Device expects manual or automatic Config updates.
     * @return the id
     */
    boolean isManualConfigUpdate() {
		return false;
	}

    /**
     * Returns the device lastModified timestamp.
     * @return the lastModified timestamp
     */
    long getLastModified() {
		return 0L;
	}

    /**
     * Touches the device
     */
    void touch() {
	}
}
