/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ************************************************************************/
package com.adobe.cq.screens.impl.aemio;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;
import javax.jcr.RepositoryException;

import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceUtil;
import org.apache.sling.commons.json.JSONException;
import org.apache.sling.commons.json.JSONObject;
import org.apache.sling.models.annotations.Model;
import org.apache.sling.models.annotations.injectorspecific.Self;

import com.adobe.cq.screens.device.Device;
import com.adobe.cq.screens.device.DeviceManager;
import com.adobe.granite.haf.annotations.ApiAction;
import com.adobe.granite.haf.annotations.ApiEntities;
import com.adobe.granite.haf.annotations.ApiModel;
import com.adobe.granite.haf.annotations.ApiProperty;
import com.adobe.granite.haf.annotations.HttpFormParam;
import com.day.cq.wcm.api.NameConstants;
import com.day.cq.wcm.api.Page;

import static com.adobe.cq.screens.binding.ScreensConstants.REST_ACT_BROADCAST_COMMAND;
import static com.adobe.cq.screens.binding.ScreensConstants.REST_DEVICE_COMMAND;
import static com.adobe.cq.screens.binding.ScreensConstants.REST_DEVICE_COMMAND_PAYLOAD;


@Model(adaptables = Resource.class)
@ApiModel(category = ScreensModelLookup.CATEGORY, type={"aem-io/screens/channel"}, modelLookup = ScreensModelLookup.class)
public class ScreensChannelModel {

    @Inject
    @Self
    protected Resource baseResource;

    @Inject
    @Named(NameConstants.NN_CONTENT)
    protected Resource jcrContent;

    @ApiProperty
    public String getTitle() {
		return null;
	}

    @ApiProperty
    public String getDescription() {
		return null;
	}

    @ApiProperty
    public boolean isSupportsOffline() {
		return false;
	}

    @ApiProperty
    public boolean isOffline() {
		return false;
	}

    @ApiEntities
    public Iterable<Resource> children() {
		return null;
	}

    @ApiAction(method = "POST", name = REST_ACT_BROADCAST_COMMAND)
    public void executeCommand(
            @HttpFormParam(REST_DEVICE_COMMAND) String msg,
            @HttpFormParam(value = REST_DEVICE_COMMAND_PAYLOAD, optional = true) String msgPayload
    ) throws RepositoryException, JSONException {
	}

}
