/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.commons.emailreply;

import org.osgi.service.event.Event;
import org.osgi.service.event.EventConstants;

/**
 * Class to storage all required email reply process constants.
 */
public final class EmailReplyConstants {

    /**
     * Property that contains path to parent resource of imported reply email message.
     */
    public static final String EMAIL_REPLY_PARENT_PATH_PROPERTY = "social:parentid";

    /**
     * Property to deliver imported reply email message path via {@link Event}.
     */
    public static final String EMAIL_REPLY_MESSAGE_PATH_PROPERTY = "email.message.path";

    /**
     * Prefix value for {@link EventConstants#EVENT_TOPIC}.
     */
    public static final String EMAIL_REPLY_EVENTS_PREFIX = "com/adobe/cq/social/commons/emailreply";

    /**
     * Full value for {@link EventConstants#EVENT_TOPIC}.
     */
    public static final String EMAIL_REPLY_IMPORT_EVENT_TOPIC = EMAIL_REPLY_EVENTS_PREFIX + "/import";

    private EmailReplyConstants() {
    }
}
