/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.enablement.resource.model.api;

import com.adobe.cq.social.scf.PageInfo;
import com.adobe.cq.social.scf.SocialCollectionComponent;

public interface EnablementResourceModelList extends SocialCollectionComponent {

    /**
     * Resource type.
     */
    public static final String RESOURCE_TYPE = "social/enablement/components/hbs/model/resourcelist";

    /**
     * Site path parameter name constant.
     */
    public static final String SITE_PATH = "sitePath";

    /**
     * Gets information about the pages for this collection. This can be used by the page block helper to easily
     * render various pagination UIs.
     * @return information about the pagination system
     */
    public PageInfo getPageInfo() {
		return null;
	}

    /**
     * Gets the path for groups root page on this enablement site if one exists. Else returns null.
     * @return
     */
    public String getGroupsPath() {
		return null;
	}

    /**
     * Gets the name for the groups root page on this enablement site if one exists. Else returns null.
     * @return
     */
    public String getGroupsName() {
		return null;
	}
    
    /**
     * Returns if the request is not being sent from creating LearningPath wizard
     * @return
     */
    public boolean getIsRequestNotFromLearningPathCreation() {
		return false;
	}

}
