/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.enablement.view.api;

import java.util.List;

import javax.jcr.RepositoryException;

import com.adobe.cq.social.enablement.learningpath.model.api.EnablementLearningPathPrerequisite;
import com.adobe.cq.social.enablement.reporting.model.api.EnablementResourceUserReportModel;
import com.adobe.cq.social.enablement.resource.model.api.EnablementAssetModel;
import com.adobe.cq.social.enablement.resource.model.api.EnablementAuthorizables;
import com.adobe.cq.social.enablement.resource.model.api.EnablementResourceModel;
import com.adobe.cq.social.scf.SocialCollectionComponent;

/**
 * @author akeith
 */
public interface EnablementLearningPathView extends SocialCollectionComponent {

    public static final String RESOURCE_TYPE = "social/enablement/components/hbs/view/learningpath";

    /**
     * @return resource title
     */
    public String getTitle() {
		return null;
	}

    /*
     * (non-Javadoc)
     * @see com.adobe.cq.social.scf.SocialComponent#getFriendlyUrl()
     */
    public String getFriendlyUrl() {
		return null;
	}

    /**
     * @return Site Path
     */
    public String getSitePagePath() {
		return null;
	}

    /**
     * @return resource cover image
     */
    public String getCoverImage() {
		return null;
	}

    /**
     * @return get the card image path
     */
    public String getCardImagePath() {
		return null;
	}

    /**
     * @return resource description
     */
    public String getDescription() {
		return null;
	}

    /**
     * @return resource site id
     */
    public String getSiteId() {
		return null;
	}

    /**
     * @return resource site language
     */
    public String getLanguage() {
		return null;
	}

    /**
     * @return resource date
     */
    public String getFriendlyDueDate() {
		return null;
	}

    /**
     * @return resource id
     */
    public String getResourceId() {
		return null;
	}

    /**
     * @return resource unique id
     */
    public String getResourceUID() {
		return null;
	}

    /**
     * Gets the list of tagIds associated with the given Enablement content.
     * @return list of tagIds
     * @throws RepositoryException on failure
     */
    public String[] getResourceTags() throws RepositoryException {
		return null;
	}

    /**
     * @return resource is published
     */
    public Boolean getIsPublished() {
		return null;
	}

    /**
     * @return resource allow anonymous
     */
    public Boolean getAllowAnonymous() {
		return null;
	}

    /**
     * @return allow catalog visibility
     */
    Boolean getAllowCatalogVisibility() {
		return null;
	}

    /**
     * @return path representing the enablement resource comments endpoint
     */
    public String getCommentsEndpoint() {
		return null;
	}

    /**
     * @return path representing the enablement resource ratings endpoint
     */
    public String getRatingsEndpoint() {
		return null;
	}

    /**
     * Returns an object representing the contacts
     * @return
     */
    public EnablementAuthorizables getContacts() {
		return null;
	}

    /**
     * Returns an object representing the authors
     * @return
     */
    public EnablementAuthorizables getAuthors() {
		return null;
	}

    /**
     * Returns an object representing the experts
     * @return
     */
    public EnablementAuthorizables getExperts() {
		return null;
	}

    /**
     * Returns an object representing the assignees
     * @return
     */
    public EnablementAuthorizables getAssignees() {
		return null;
	}

    /**
     * @return
     */
    public Boolean getAllPrerequisitesCompleted() {
		return null;
	}

    public EnablementResourceUserReportModel getUserReport() {
		return null;
	}

    public EnablementResourceModel getEnablementResourceModel() {
		return null;
	}

    /**
     * @return
     */
    public String getEnablementType() {
		return null;
	}

    public List<EnablementLearningPathPrerequisite> getPrerequisites() {
		return null;
	}

    public List<EnablementLearningPathPrerequisite> getUnfinishedPrerequisites() {
		return null;
	}

    public Boolean getEnforceOrder() {
		return null;
	}

    /**
     * Returns an object representing the resource large asset.
     * @return
     */
    public EnablementAssetModel getLargeAsset() {
		return null;
	}

    /**
     * Returns an object representing the resource small asset.
     * @return
     */
    public EnablementAssetModel getSmallAsset() {
		return null;
	}

    /**
     * Returns an object representing the resource content fragment asset.
     * @return
     */
    public EnablementAssetModel getFragmentAsset() {
		return null;
	}

}
