/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.group.client.api;

import java.util.List;

import javax.jcr.Session;

import com.adobe.cq.social.scf.SocialCollectionComponent;
import org.osgi.annotation.versioning.ProviderType;

@ProviderType
public interface CommunityGroupCollection extends SocialCollectionComponent {

    String RESOURCE_TYPE = "social/group/components/hbs/communitygroups";

    String GROUP_ADMIN_PERMISSIONS = Session.ACTION_ADD_NODE + "," + Session.ACTION_READ + ","
            + Session.ACTION_REMOVE + "," + Session.ACTION_SET_PROPERTY;

    /**
     * The default property value for allowing moves.
     */
    boolean PV_DEFAULT_ALLOW_PUBLISH_CREATION = true;
    static String ALLOW_PUBLISH_CREATION = "allowPublishCreation";

    /**
     * The restricted users group.O Checks if privileged users group is set.
     */
    static String ALLOW_PRIVILEGED_MEMBERS = "allowPrivilegedMembers";
    static String PRIVILEGED_USERS_GROUP = "cq:privilegedMembers";

    boolean isCanAdd() {
		return false;
	}

    String getDefaultImage() {
		return null;
	}

    List<Object> getAllowedTemplates() {
		return null;
	}
}
