/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.members.api;

import java.util.List;
import java.util.Map;

import aQute.bnd.annotation.ProviderType;

import com.adobe.cq.social.scf.SocialAuthorizable;
import com.adobe.cq.social.scf.User;
import com.adobe.cq.social.user.api.UserProfile;
import com.adobe.cq.social.user.internal.UserProfileBadge;

@ProviderType
public interface CommunityMemberUserProfile extends UserProfile {
    String RESOURCE_TYPE = "social/members/components/hbs/userprofile";

    /**
     * Get the groups which user is member of.
     */
    SocialAuthorizable[] getMemberOfGroups() {
		return null;
	}

    /**
     * Get the sites which user is member of.
     * @return List of Map with the following properties: name, siteId, siteUrlName, url, sitePagePath, creator,
     *         userRoles
     */
    List<Map<String, String>> getMemberOfSites() {
		return null;
	}

    /**
     * Get the badges which assigned to the user.
     * @return List of badges witch assigned to the user.
     */
    List<UserProfileBadge> getAssignedBadges() {
		return null;
	}

    /**
     * Get the earned badges which associated with the user.
     * @return List of earned badges which associated with the user.
     */
    List<UserProfileBadge> getEarnedBadges() {
		return null;
	}

    /**
     * Get the top earned badges which assigned to the user.
     * @return List of top earned badges which associated with the user.
     */
    List<UserProfileBadge> getTopEarnedBadges() {
		return null;
	}

    /**
     * @return true if the user is disabled, false otherwise
     */
    boolean getDisabled() {
		return false;
	}

    /**
     * Checks if is users UGC Contributions has a limit
     * @return true, if users UGC contribution is limited
     */
    Boolean isUserUGCLimited() {
		return null;
	}
}
