/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 *************************************************************************/

/**
 * This package contains interfaces for getting operations available for community users/groups and classes, that
 * implement functionality for community group post operation.
 *
 * The {@link com.adobe.cq.social.members.endpoints.AbstractCommunityMemberGroupProfileOperation} class provides
 * functionality to perform post operation and sends the response using the provided session.
 *
 * The {@link com.adobe.cq.social.members.endpoints.AbstractCommunityMemberGroupProfileOperationService}
 * class contains implementation of 
 * {@link com.adobe.cq.social.members.endpoints.CommunityMemberGroupProfileOperations} class.
 *
 * The {@link com.adobe.cq.social.members.endpoints.CommunityMemberGroupProfileOperationExtension} class provides
 * functionality for getting operation extensions for community group.
 *
 * The {@link com.adobe.cq.social.members.endpoints.CommunityMemberGroupProfileOperations} class provides
 * functionality to perform operations on community groups.
 *
 * The {@link com.adobe.cq.social.members.endpoints.CommunityMemberUserProfileOperationExtension} class provides
 * functionality for getting operation extensions for community user.
 *
 * The {@link com.adobe.cq.social.members.endpoints.CommunityMemberUserProfileOperations} class provides
 * functionality to perform operations on community users.
 */
@Version("1.4.0")
package com.adobe.cq.social.members.endpoints;

import aQute.bnd.annotation.Version;

