/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.srp.internal;

import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang3.StringUtils;

/**
 * The parsed facet results.
 */
public class FacetResults {
    private Map<String, Object> facetFieldsFromResults;
    private final List<Map<String, Object>> documents;
    private Map<String, Object> facetAggregations;
    private final List<String> facetFields;
    private Map<String, Map<String, FacetPivotResults>> pivotAggregations;
    private final List<String> facetPivotFields;

    /**
     * Constructor.
     * @param docs the list of documents
     * @param facetFields the input list of facets
     * @param pivotFields the input list of facet pivot fields
     * @param facetFieldsFromResults the facet field results fetched from the data service
     * @param facetPivotFromResults the pivot field results fetched from the data service
     */
    public FacetResults(final List<Map<String, Object>> docs, final List<String> facetFields,
        final List<String> pivotFields, final Map<String, Object> facetFieldsFromResults,
        final Map<String, Object> facetPivotFromResults) {
        this.documents = docs;
        this.facetFields = facetFields;
        this.facetPivotFields = pivotFields;
        if (facetFields != null && !facetFields.isEmpty()) {
            this.facetFieldsFromResults = facetFieldsFromResults;

        } else {
            this.facetFieldsFromResults = Collections.emptyMap(); // create empty object
        }
        if (pivotFields != null && !pivotFields.isEmpty()) {
            pivotAggregations = getForEachFacetPivotField(pivotFields, facetPivotFromResults);

        }
    }

    /**
     * @param pivotFields the list of pivot.field used in the query
     * @param facetPivotNode the "facet_pivot" node in the json reponse
     * @return a Map<String, Object> where the key is the pivot.field
     */
    private Map<String, Map<String, FacetPivotResults>> getForEachFacetPivotField(final List<String> pivotFields,
        final Map<String, Object> facetPivotNode) {
			return null;
		}

    /**
     * @param pivotField one pivot.field
     * @param pivotArray the json array for the pivot.field
     * @return a List of FacetPivotResults
     */
    @SuppressWarnings({"unchecked", "rawtypes"})
    private Map<String, FacetPivotResults> getPivot(final String pivotField, final Object[] pivotArray) {
		return null;
	}

    /**
     * A method to return the first aggregation of the first field for the first pivot.field.
     * @return a Map where the key is the value of the first field in the first pivot.field
     */
    public Map<String, Object> getPivotAggregation() {
		return null;
	}

    /**
     * @param fpf the facet.pivot field
     * @return a Map where the key is the value of the first field in the first pivot.field
     */
    public Map<String, Object> getPivotAggregation(final String fpf) {
		return null;
	}

    /**
     * Return the aggregate with field matching. e.g. getPivotAggregation(":parent,reponse,:key",
     * ["/some/path/to/a/particular/parent","-1"])
     * @param fpf the facet.pivot field used in the search
     * @param fieldsFilter a list of
     * @return a Map of the aggregate or empty Map if nothing is found matchig filters
     */
    public Map<String, Integer> getPivotAggregation(final String fpf, final List<String> fieldsFilter) {
		return null;
	}

    /**
     * Return an aggregate (in a Map), given a list of FacetPivotResults.
     * @param listOfResults
     * @return
     */
    private Map<String, Integer> pivotToMap(final Map<String, FacetPivotResults> listOfResults) {
		return null;
	}

    /**
     * Get the facetAggregations.
     * @return a Map from the values to their counts
     */
    public Map<String, Object> getAggregation() {
		return null;
	}

    /**
     * Get the documents.
     * @return the list of documents
     */
    public List<Map<String, Object>> getDocs() {
		return null;
	}

    /**
     * A method for getting an empty facet result.
     * @return An empty result
     */
    public static FacetResults emptyResults() {
		return null;
	}

    /**
     * Data structure to store a single pivot result.
     */
    private static class FacetPivotResults {
        private final String value;
        private final Integer count;
        private final Map<String, FacetPivotResults> pivot;

        FacetPivotResults(final String value, final Integer count, final Map<String, FacetPivotResults> pivot) {
            this.value = value;
            this.count = count;
            this.pivot = pivot;
        }

        public String getValue() {
			return null;
		}

        public Integer getCount() {
			return null;
		}

        public Map<String, FacetPivotResults> getPivot() {
			return null;
		}
    }

}
