/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.subscriptions.endpoint;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.jcr.Session;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.StringUtils;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Reference;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.request.RequestParameterMap;
import org.apache.sling.api.resource.LoginException;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ResourceUtil;
import org.apache.sling.api.resource.SyntheticResource;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.social.graph.SocialGraph;
import com.adobe.cq.social.graph.Vertex;
import com.adobe.cq.social.scf.ClientUtilities;
import com.adobe.cq.social.scf.Operation;
import com.adobe.cq.social.scf.OperationException;
import com.adobe.cq.social.scf.OperationExtension;
import com.adobe.cq.social.scf.SocialComponent;
import com.adobe.cq.social.scf.SocialComponentFactory;
import com.adobe.cq.social.scf.SocialComponentFactoryManager;
import com.adobe.cq.social.scf.core.operations.AbstractOperationService;
import com.adobe.cq.social.subscriptions.api.SubscriptionManager;
import com.adobe.cq.social.subscriptions.api.SubscriptionType;
import com.adobe.cq.social.subscriptions.client.api.SubscriptionCollection;
import com.adobe.cq.social.subscriptions.client.api.SubscriptionCollectionComponentFactory;
import com.adobe.cq.social.subscriptions.endpoint.SubscriptionCollectionOperationExtension.SubscriptionCollectionOperation;
import com.adobe.cq.social.ugcbase.CollabUser;
import com.adobe.granite.socialgraph.Direction;
import com.adobe.granite.socialgraph.Relationship;

/**
 * Provides abstract implementation of the Subscription operation..
 * @param <T> is a {@link OperationExtension} that will be used as hooks by the extending class.
 * @param <U> is a {@link Operation} that is being provided by the extending class.
 */
@Component(metatype = false, componentAbstract = true)
public abstract class AbstractSubscriptionCollectionOperationService<T extends SubscriptionCollectionOperationExtension, U extends SubscriptionCollectionOperation>
    extends AbstractOperationService<T, U, SubscriptionCollection> implements SubscriptionCollectionOperations {
    @Reference
    SubscriptionManager subscriptionManager;
    @Reference
    private SocialComponentFactoryManager componentFactoryManager;

    String subscribedId;
    String userId;
    String types[];
    Boolean states[];
    ResourceResolver resolver;
    private static List<String> PARAM_LIST = Arrays.asList(new String[]{PROP_SUBSCRIBED_ID, PROP_USER_ID, PROP_TYPES,
        PROP_STATES, ":operation"});
    private static Logger LOG = LoggerFactory.getLogger(AbstractSubscriptionCollectionOperationService.class);

    @Override
    public SocialComponent update(final SlingHttpServletRequest request) throws OperationException {
		return null;
	}

    private SocialComponent getSocialComponent(final SlingHttpServletRequest request,
        final List<Relationship> subscriptions) {
			return null;
		}

    protected String getResourceType() {
		return null;
	}

    protected abstract U getUpdateOperation() {
		return null;
	}

    protected abstract ResourceResolver getPrivilegedResolver() throws LoginException {
		return null;
	}
}
