/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.wcm.mobile.qrcode.servlet;

import com.day.cq.commons.Externalizer;
import com.day.cq.wcm.commons.AbstractImageServlet;
import com.day.image.Layer;
import com.google.zxing.qrcode.decoder.ErrorCorrectionLevel;
import com.google.zxing.qrcode.encoder.Encoder;
import com.google.zxing.qrcode.encoder.QRCode;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Properties;
import org.apache.felix.scr.annotations.Property;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.commons.osgi.OsgiUtil;
import org.osgi.framework.Constants;
import org.osgi.service.component.ComponentContext;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.servlet.Servlet;
import javax.servlet.http.HttpServletResponse;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.util.Dictionary;

@Component(metatype=true,
           label="AEM WCM QR-Code Generator Servlet",
           immediate=true)
@Service(value=Servlet.class)
@Properties( {
        @Property(name=Constants.SERVICE_DESCRIPTION,
                  value="QR Code Image Generator"),
        @Property(name="sling.servlet.paths",
                  value="/libs/wcm/mobile/qrcode",
                  propertyPrivate=true),
        @Property(name="sling.servlet.extensions",
                  value="png",
                  propertyPrivate=true),
        @Property(name="sling.servlet.methods",
                  value="GET",
                  propertyPrivate=true)
    } )
@SuppressWarnings("serial")
public class QRCodeImageGenerator extends AbstractImageServlet {

    @Reference
    private Externalizer externalizer = null;

    private static final int QR_MARGIN = 2;

    private static final String DATA_NAME_WHITELIST  = "cq.wcm.qrcode.servlet.whitelist";
    private static final String DATA_WHITELIST_LABEL = "Whitelist URL";
    private static final String DATA_WHITELIST_DESC  = "List of regular expressions (regex) indicating which URLs are allowed for the creation of QR Codes images. The Author and Publish servers, based on the Externalizer service, are automatically whitelisted.";
    private static final String DATA_WHITELIST_VALUE1 = "(https://build.phonegap.com/.*)";
    @Property(name=QRCodeImageGenerator.DATA_NAME_WHITELIST,
              label=QRCodeImageGenerator.DATA_WHITELIST_LABEL,
              value={QRCodeImageGenerator.DATA_WHITELIST_VALUE1},
              description=QRCodeImageGenerator.DATA_WHITELIST_DESC,
              propertyPrivate=false,
              cardinality=1)

    private String[] dataNameWhitelist;
    private String author;
    private String publish;
    private String errMessage;

    private static final Logger log = LoggerFactory.getLogger(QRCodeImageGenerator.class);

    protected void activate(ComponentContext componentContext) {
	}

    protected Layer createLayer(ImageContext c) throws RepositoryException, IOException {
		return null;
	}

    protected void writeLayer(SlingHttpServletRequest req, SlingHttpServletResponse resp, ImageContext c, Layer layer)
                throws IOException, RepositoryException {
				}

    protected boolean checkModifiedSince(SlingHttpServletRequest req, SlingHttpServletResponse resp) {
		return false;
	}
}
