/*******************************************************************************
 * ADOBE CONFIDENTIAL
 * __________________
 * <p/>
 * Copyright 2016 Adobe Systems Incorporated
 * All Rights Reserved.
 * <p/>
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ******************************************************************************/

package com.adobe.cq.xf;

import org.apache.sling.api.resource.ValueMap;

import java.util.List;

/**
 * Model object that represents an experience fragment. This experience fragment can have multiple variations
 */
public interface ExperienceFragment {

    /**
     * Retrieves all the variations of this experience fragment.
     * @return a list of {@link ExperienceFragmentVariation} objects. If the experience fragment has no variations then an emtpy list is returned.
     */
    List<ExperienceFragmentVariation> getVariations() {
		return null;
	}

    /**
     * Retrieves all the variations of this experience fragment, filtered by one or more types
     * @param type the type(s) of variations to be retrieved
     * @return a list of {@link ExperienceFragmentVariation} objects. If the experience fragment has no variations of the specified type(s) then an empty list is returned.
     */
    List<ExperienceFragmentVariation> getVariations(String... type) {
		return null;
	}

    /**
     * Retrieves the path of this experience fragment
     * @return the path of the variation page
     */
    String getPath() {
		return null;
	}

    /**
     * Retrieves the properties of this experience fragment
     * @return a {@link ValueMap} object
     */
    ValueMap getProperties() {
		return null;
	}


}
