/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.granite.haf.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Target(ElementType.PARAMETER)
@Retention(RetentionPolicy.RUNTIME)
/**
 * Use this annotation to bind specific java parameters to HTTP form parameters coming from the request. These will only be processed if the method has an ApiAction annotation.
 */
public @interface HttpFormParam {
    /**
     * The name of the HTTP parameter to bind to.
     */
    public String value();

    /**
     * Whether the parameter should be considered optional.  If it is, and no value for it is passed in the request
     * the method will receive null as the value.
     * @return The optional property
     */
    public boolean optional() default false;
}
