/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.rest.converter.siren;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.apache.sling.api.resource.Resource;
import org.json.JSONException;
import org.json.JSONObject;

import com.adobe.granite.rest.Constants;
import com.adobe.granite.rest.converter.ResourceConverterContext;
import com.adobe.granite.rest.converter.ResourceConverterException;
import com.adobe.granite.rest.filter.Filter;
import com.adobe.granite.rest.filter.impl.FilteredIterator;
import com.adobe.granite.rest.utils.Resources;
import com.adobe.reef.siren.Entity;
import com.adobe.reef.siren.Link;
import com.adobe.reef.siren.builder.BuilderException;

/**
 * {@code AbstractCollectionConverter} is a base implementation of {@link AbstractSirenConverter} for pageable
 * resources. It provides functionality additional functionality for paging.
 * {@link com.adobe.granite.rest.converter.ResourceConverter} implementations are encouraged to extend from this
 * abstract base class.
 */
public abstract class AbstractPageableSirenConverter extends AbstractSirenConverter {

    public AbstractPageableSirenConverter(Resource resource) {
        super(resource);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected List<Link> getLinks(ResourceConverterContext context, boolean isChild) throws BuilderException,
        ResourceConverterException {
			return null;
		}

    /**
     * Returns an Entity object for the provided {@link org.apache.sling.api.resource.Resource child}.
     * @param context Converter context
     * @param child Child resource to get entity for
     * @return Siren entity
     * @throws ResourceConverterException If an error occurs during conversion
     */
    protected abstract Entity getEntity(ResourceConverterContext context, Resource child)
        throws ResourceConverterException {
		return null;
	}

    @Override
    protected List<Entity> getEntities(ResourceConverterContext context, Iterator<Resource> children)
        throws BuilderException {
			return null;
		}

    /**
     * {@inheritDoc}
     */
    @Override
    protected Map<String, Object> getProperties(ResourceConverterContext context, boolean isChild) {
		return null;
	}
}
