/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.rest.utils;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import org.apache.commons.lang.ArrayUtils;
import org.apache.sling.api.resource.ModifiableValueMap;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ValueMap;
import org.apache.sling.api.wrappers.ModifiableValueMapDecorator;
import org.apache.sling.api.wrappers.ValueMapDecorator;

/**
 * A value map wrapper which implements deep reading/writing of properties
 * based on the resource tree and a set of exposed sub-nodes. Note that only
 * properties of exposed sub-nodes can be updated.
 */
public class DeepModifiableValueMapDecorator extends ModifiableValueMapDecorator {

    protected final String pathPrefix;

    protected final ResourceResolver resolver;

    protected final Map<String,Object> base;

    protected final String[] subnodes;

    public DeepModifiableValueMapDecorator(final Resource resource, final Map<String,Object> base, final String[] subnodes) {
        super(base);
        this.pathPrefix = resource.getPath() + "/";
        this.resolver = resource.getResourceResolver();
        this.base = base;
        this.subnodes = subnodes;
    }

    public DeepModifiableValueMapDecorator(final Resource resource, final Map<String,Object> base) {
        this(resource, base, new String[]{});
    }

    protected ValueMap getValueMap(final String name) {
		return null;
	}

    protected String getPropertyName(final String name) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public <T> T get(String name, final Class<T> type) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public <T> T get(String name, T defaultValue) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean containsKey(final Object key) {
		return false;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public Object get(final Object key) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public Object put(String key, Object value) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public void putAll(Map<? extends String, ?> t) {
	}

    /**
     * {@inheritDoc}
     */
    public Set<String> keySet() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public Collection<Object> values() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public Set<Entry<String, Object>> entrySet() {
		return null;
	}

    /**
     * Build the aggregated map containing all values of the base ValueMap plus
     * the sub-nodes as nested ValueMap's.
     */
    private ValueMap buildAggregatedMap() {
		return null;
	}

}
