/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.security.user.ui;

import aQute.bnd.annotation.ProviderType;

/**
 * Represents an interface for datasource items related to authorizables and is intended to be used by UI components.
 */
@ProviderType
public interface AuthorizableModel {

    /**
     * @return the authorizable ID or {@code null} if this information is not available.
     */
    String getId() {
		return null;
	}

    /**
     * @return the authorizable home path or {@code null} if this information is not available.
     */
    String getHomePath() {
		return null;
	}

    /**
     * @return the authorizable name or {@code null} if this information is not available.
     */
    String getName() {
		return null;
	}

    /**
     * @return {@code true} if the authorizable has been created 24h ago.<br>
     *         {@code false} otherwise
     */
    boolean isNew() {
		return false;
	}

    /**
     * Returns the formatted last modification date of the authorizable or {@code null} if this information is not available.
     *
     * @return last change date formatted using yyyy-MM-dd HH:mm pattern or {@code null}
     */
    String getLastModified() {
		return null;
	}

    /**
     * Returns the formatted user name by whom the authorizable has been modified last time or {@code null} if this information is not
     * available.
     *
     * @return formatted user name or {@code null} if an error occurred.
     */
    String getLastModifiedBy() {
		return null;
	}

    /**
     * Returns the formatted last publication date of the authorizable or {@code null} if this information is not available.
     *
     * @return last publish date formatted using yyyy-MM-dd HH:mm pattern or {@code null}
     */
    String getLastPublished() {
		return null;
	}

    /**
     * Returns the formatted user name by whom the authorizable has been published last time or {@code null} if this information is not
     * available.
     *
     * @return formatted user name or {@code null} if an error occurred.
     */
    String getLastPublishedBy() {
		return null;
	}
}
