/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.taskmanagement;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Used to specify conditions in a {@link Filter} for a TaskManagement query
 */
public class Condition implements Cloneable {

    /**
     * Used to define the task property names of the condition
     */
    private List<String> propertyNames = new ArrayList<String>();

    /**
     * Used to define the ComparisonOperator of the condition
     */
    private ComparisonOperator comparisonOperator;

    /**
     * Used to define the comparison value of the condition
     */
    private Object comparisonValue;

    /**
     * Built-in task properties
     */
    private List<TaskProperty> taskProperties = new ArrayList<TaskProperty>();

    /**
     * Construct a new Condition instance with null property,
     * comparisonOperator and comparisonValue fields.
     */
    public Condition() {

    }

    /**
     * Get the name of the task property for this condition.
     *
     * @return the task property name.
     */
    public String getPropertyName() {
		return null;
	}

    /**
     * Set the name of the task property for this condition.
     * you may either set a taskProperty or a #setTaskProperty not both
     *
     * @param aPropertyName the task property name.
     */
    public void setPropertyName(String aPropertyName) {
	}

    /**
     * Gets the names of the task properties for this condition
     * 
     * @return the task property names or {@code null}
     */
    public String[] getPropertyNames() {
		return null;
	}

    /**
     * Set the names of the task properties for this condition. You may either
     * use {@link #setPropertyNames(String...)} or
     * {@link #setTaskProperties(TaskProperty...)} but not both.
     * 
     * @param propertyNames
     *            the task property names
     */
    public void setPropertyNames(String... propertyNames) {
	}

    /**
     * gets the taskProperty set for this condition
     * @return the taskProperty
     */
    public TaskProperty getTaskProperty() {
		return null;
	}

    /**
     * sets a built-in task property for this condition.
     * you may either set a taskProperty or a #setPropertyName not both
     * @param taskProperty the built in task property for this condition
     */
    public void setTaskProperty(TaskProperty taskProperty) {
	}

    /**
     * Gets the task properties set for this condition.
     * 
     * @return the task properties
     */
    public TaskProperty[] getTaskProperties() {
		return null;
	}

    /**
     * Sets built-in task properties for this condition. You may either use
     * {@link #setTaskProperties(TaskProperty...)} or
     * {@link #setPropertyNames(String...)} but not both.
     * 
     * @param taskProperties
     *            the built-in task properties for this condition
     */
    public void setTaskProperties(TaskProperty... taskProperties ) {
	}

    /**
     * Get the ComparisonOperator object for this condition.
     *
     * @return The ComparisonOperator for this condition or null if no ComparisonOperator
     *         has been set.
     */
    public ComparisonOperator getComparisonOperator() {
		return null;
	}

    /**
     * Set the ComparisonOperator object for this condition
     *
     * @param aComparisonOperator The ComparisonOperator object to set
     */
    public void setComparisonOperator(ComparisonOperator aComparisonOperator) {
	}

    /**
     * Get the comparison value Object for this condition.
     *
     * @return The comparison value as an Object for this condition or null if no comparison value
     *         has been set.
     */
    public Object getComparisonValue() {
		return null;
	}

    /**
     * Set the comparison value Object for this condition
     *
     * @param aComparisonValue The comparison value Object to set
     */
    public void setComparisonValue(Object aComparisonValue) {
	}

    @Override
    public Object clone() throws CloneNotSupportedException {
		return null;
	}
}
