/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.ui.components;

import java.util.Locale;

import javax.servlet.jsp.PageContext;

import org.apache.sling.api.SlingHttpServletRequest;

import org.osgi.annotation.versioning.ProviderType;

/**
 * A service to resolve an expression into an actual object.
 */
@ProviderType
public interface ExpressionResolver {

    /**
     * Resolves the given expression.
     *
     * @param expression The expression to resolve
     * @param locale The locale
     * @param expectedType The type the result of the expression will be coerced to after evaluation
     * @param pageContext The current page context
     * @param <T> The type of the resolved expression
     * @return The result of expression
     */
    <T> T resolve(String expression, Locale locale, Class<T> expectedType, PageContext pageContext) {
		return null;
	}

    /**
     * Resolves the given expression.
     *
     * @param expression The expression to resolve
     * @param locale The locale
     * @param expectedType The type the result of the expression will be coerced to after evaluation
     * @param request The current request
     * @param <T> The type of the resolved expression
     * @return The result of expression
     */
    <T> T resolve(String expression, Locale locale, Class<T> expectedType, SlingHttpServletRequest request) {
		return null;
	}
}
