/**
 * ADOBE SYSTEMS INCORPORATED
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 * NOTICE:  Adobe permits you to use, modify, and distribute this file in accordance with the
 * terms of the Adobe license agreement accompanying it.  If you have received this file from a
 * source other than Adobe, then your use, modification, or distribution of it requires the prior
 * written permission of Adobe.
 */
package com.adobe.social.integrations.livefyre.config.api;

import javax.annotation.Nonnull;

import com.adobe.granite.crypto.CryptoException;

/**
 * Represents the current configuration of LiveFyre on AEM.
 * @author mcweeney
 */
public interface LivefyreConfig {
    /**
     * The Site ID that is configured.
     * @return siteId usually a number
     */
    @Nonnull
    String getSiteId() {
		return null;
	}

    /**
     * The Site key that is configured. This value is always stored encrypted by AEM.
     * @return the unencrypted site key. Do not send this on a wire.
     * @throws CryptoException thrown when decryption of the value fails
     */
    @Nonnull
    String getSiteKey() throws CryptoException {
		return null;
	}

    /**
     * The Network key that is configured. This value is always stored encrypted by AEM.
     * @return the unencrypted site key. Do not send this on a wire.
     * @throws CryptoException thrown when decryption of the value fails
     */
    @Nonnull
    String getNetworkKey() throws CryptoException {
		return null;
	}

    /**
     * The Network name, must end with .fyre.co.
     * @return the network name
     */
    @Nonnull
    String getNetworkName() {
		return null;
	}
}
