/***************************************************************************/
/*                                                                         */
/*                      ADOBE CONFIDENTIAL                                 */
/*                      _ _ _ _ _ _ _ _ _ _                                */
/*                                                                         */
/*  Copyright 2001-2002, Adobe Systems Incorporated                        */
/*  All Rights Reserved.                                                   */
/*                                                                         */
/*  NOTICE: All information contained herein is, and remains the property  */
/*  of Adobe Systems Incorporated and its suppliers, if any.  The          */
/*  intellectual and technical concepts contained herein are proprietary   */
/*  to Adobe Systems Incorporated and its suppliers and may be covered by  */
/*  U.S. and Foreign Patents, patents in process, and are protected by     */
/*  trade secret or copyright law.  Dissemination of this information or   */
/*  reproduction of this material is strictly forbidden unless prior       */
/*  written permission is obtained from Adobe Systems Incorporated.        */
/*                                                                         */
/***************************************************************************/
package com.adobe.versioncue.nativecomm;

/**
 * Exception used by INativeService.
 * 
 * @see com.adobe.versioncue.nativecomm.INativeService
 * 
 * @author <a href="mailto:tnaroska@adobe.com">Timo Naroska</a>
 * @version $Revision: #1 $
 */
public class NativeCommException extends Exception
{
	// -------------------------------------------------------------------------- Public Constructor

	/** UID */
	private static final long serialVersionUID = -1284409855773874342L;

	/**
	 * Constructor for NativeCommException.
	 * 
	 * @param message detail message
	 */
	public NativeCommException(String message)
	{
		super(message);
	}

	/**
	 * Constructor for NativeCommException.
	 * 
	 * @param message detail message
	 * @param cause the cause
	 */
	public NativeCommException(String message, Throwable cause)
	{
		super(message, cause);
	}
}