/*
 * File: ParamInfoGroup.java
 * ************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.xmp.schema.rng.model;

import java.util.Stack;

/**
 * Defines a group of constraints on a property value.
 * 
 * @author pwollek
 */
public class ParamInfoGroup implements ParamInfo
{
	/**
	 * Operator to define relatioship between constraints defined by a stack of {@link ParamInfo} objects
	 * 
	 * @author pwollek
	 */
	public enum Operator
	{
		/**
		 * or operator
		 */
		kOR,
		/**
		 * and operator
		 */
		kAND;
	}

	private Stack<ParamInfo> mParamInfos; // ParamInfoImpl and/or ParamInfoGroup

	private final Operator mOperator;
	
	private boolean isChoice; // Represents if this group is defined inside a <rng:choice/>

	/**
	 * 
	 * Constructs a new ParamInfoGroup.
	 * 
	 * @param operator
	 *            Operator which defines relationship between a stack of {@link ParamInfo} objects
	 */
	public ParamInfoGroup(Operator operator)
	{
		mOperator = operator;
		mParamInfos = new Stack<ParamInfo>();
	}

	/**
	 * @return the mOperator
	 */
	public Operator getOperator()
	{
		return null;
	}

	/**
	 * Pushes the {@link ParamInfo} object in this {@link ParamInfoGroup}
	 * 
	 * @param info
	 *            {@link ParamInfo} object to push
	 */
	public void push(ParamInfo info)
	{
	}

	ParamInfo pop()
	{
		return null;
	}

	/**
	 * Tests if this ParamInfoGroup is empty.
	 * 
	 * @return <code>true</code> if and only if this ParamInfoGroup contains no ParamInfo items; <code>false</code>
	 *         otherwise.
	 */
	public boolean empty()
	{
		return false;
	}

	int size()
	{
		return 0;
	}

	/**
	 * @return Stack of {@link ParamInfo} objects contained in this {@link ParamInfoGroup}
	 */
	public Stack<ParamInfo> getParams()
	{
		return null;
	}

	public boolean equals(ParamInfo param)
	{
		return false;
	}
	
	/**
	 * Set if this param group is defined inside a rng:choice
	 * @param isChoice boolean
	 */
	public void setChoice(boolean isChoice)
	{
	}
	
	/**
	 * Gets if this param group is defined inside a rng:choice
	 * @return boolean
	 */
	public boolean isChoice()
	{
		return false;
	}
	
	@Override
	public String toString()
	{
		return null;
	}
}
