/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and may be covered by U.S. and Foreign Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.analytics.sitecatalyst;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.jcr.Node;

import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.settings.SlingSettingsService;

import com.day.cq.wcm.api.Page;
import com.day.cq.wcm.webservicesupport.Configuration;
import com.day.crx.JcrConstants;

public class SitecatalystUtil {

    private SitecatalystUtil() {
    }

    /**
     * Returns server URL according to request scheme. If the scheme is HTTP the
     * tracking server is returned otherwise the secure tracking server is
     * returned.
     * 
     * @param request  the request
     * @param config the configuration
     * @return server URL
     */
    public static String getServer(SlingHttpServletRequest request, Configuration config) {
		return null;
	}

    /**
     * Returns a comma separated list of report suites depending on the current
     * run mode of the server. If no report suite matches the current run mode
     * an empty string is returned.
     * 
     * @param settingsService  SlingSettingsService
     * @param configuration the configuratin
     * @return comma separated list of report suites for runmode of current server
     */
    public static String getReportSuites(SlingSettingsService settingsService, Configuration configuration) {
		return null;
	}

    /**
     * Returns number of domain name periods.
     * 
     * @param request the request
     * @param server the server url
     * @return number ofdomain name periods
     */
    public static Integer getCookieDomainNamePeriod(SlingHttpServletRequest request, String server) {
		return null;
	}

    /**
     * Formats the resource path of a Resource <code>pageResource</code>
     * relative to the provided
     * {@link com.day.cq.wcm.webservicesupport.Configuration} path. A trailing
     * slash will be removed if present, all other slashes will be replaced by
     * colons.
     * <p>
     * <code>/content/geometrixx/en/support</code> will be formatted to
     * <code>content:geometrixx:en:support</code>
     * </p>
     * @param pageResource  page Resource
     * 
     * @param configuration SiteCatalyst configuration
     * @return Formatted path
     */
    public static String getFormattedPagePath(Resource pageResource, Configuration configuration) {
		return null;
	}

    /**
     * Ascends the {@link Resource} until a {@link Page} with a valid analytics
     * configuration is found. The configuration is considered valid if the node
     * has a property cq:services.
     * 
     * @param resolver {@link ResourceResolver}
     * @param resource {@link Resource}
     * @return Analytics resource or <code>null</code> if none could be found.
     */
    public static Resource findAnalyticsResource(ResourceResolver resolver, Resource resource) {
		return null;
	}

    /**
     * Returns one of the configured report suites based on the following rules:
     * return first publish report suite, if not, return first report suite for all
     * run modes and if still nothing available return first author report suite
     * 
     * @param config the Analytics configuration
     * @return the preferred report suite ID
     */
    public static String getPublishPreferredReportSuite(Configuration config) {
		return null;
	}

}
