/*******************************************************************************
 * ADOBE CONFIDENTIAL
 * __________________
 *
 * Copyright 2017 Adobe Systems Incorporated
 * All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ******************************************************************************/

package com.day.cq.analytics.testandtarget;

/**
 * The constants used
 */
public final class TargetConstants {

    // maximum size of the attributes list
    public static final int MAX_METADATA_ITEMS = 15;

    // maximum size of the attribute name / attribute value
    public static final int MAX_METADATA_ITEM_LENGTH = 250;

    // the name of the Edit URL attribute
    public static final String ATTR_MAC_METADATA_EDIT_URL = "editURL";

    // the name of the Remote Modified By attribute
    public static final String ATTR_MAC_METADATA_MODIFIED_BY = "remoteModifiedBy";

    // the name of the Source Product Name attribute
    public static final String ATTR_MAC_MEDATATA_SOURCE_PRODUCT = "sourceProductName";

    // the Source Product attribute value
    public static final String MAC_METADATA_SOURCE_PRODUCT = "Adobe Experience Manager";

    private TargetConstants() {

    }
}
