/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.commons;

import java.io.Writer;
import java.util.Set;

import javax.jcr.Node;
import javax.jcr.NodeIterator;
import javax.jcr.Property;
import javax.jcr.RepositoryException;
import javax.jcr.ValueFormatException;

import org.apache.sling.commons.json.JSONException;
import org.apache.sling.commons.json.io.JSONWriter;
import org.apache.sling.commons.json.jcr.JsonItemWriter;

/**
 * Extension of the JsonItemWriter that uses a {@link TidyJSONWriter}.
 */
public class TidyJsonItemWriter extends JsonItemWriter {

    /**
     * flag indicating if output should be nicely formatted
     */
    private boolean tidy;

    /**
     * Constructor
     */
    public TidyJsonItemWriter(Set<String> propertyNamesToIgnore) {
        super(propertyNamesToIgnore);
    }

    /**
     * Checks if the output is nicely formatted.
     * @return <code>true</code> if nicely formatted
     */
    public boolean isTidy() {
		return false;
	}

    /**
     * Controls if output should be nicely formatted.
     * @param tidy <code>true</code> to nicely format.
     */
    public void setTidy(boolean tidy) {
	}

    /** Dump given node in JSON, optionally recursing into its child nodes */
    public void dump(Node node, JSONWriter w, int maxRecursionLevels)
            throws RepositoryException, JSONException {
			}

    /**
     * {@inheritDoc}
     */
    public void dump(Node node, Writer w, int maxRecursionLevels)
            throws RepositoryException, JSONException {
			}

    /**
     * Dump all Nodes of given NodeIterator in JSON
     *
     * @throws JSONException
     */
    public void dump(NodeIterator it, JSONWriter w) throws RepositoryException, JSONException {
	}

    /**
     * {@inheritDoc}
     */
    public void dump(NodeIterator it, Writer out) throws RepositoryException, JSONException {
	}

    /**
     * Dump the property in JSON
     *
     * @throws JSONException
     */
    public void dump(Property p, JSONWriter w) throws JSONException, RepositoryException {
	}

    /**
     * {@inheritDoc}
     */
    public void dump(Property p, Writer w) throws JSONException, ValueFormatException, RepositoryException {
	}
}