/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.compat.codeupgrade;


import aQute.bnd.annotation.ConsumerType;

/**
 * Interface for Services that declare a filter logic for CodeUpgradeTasks that should not be executed.
 * Is consulted by the executor for each found {@link CodeUpgradeTask}
 */
@ConsumerType
public interface CodeUpgradeTaskFilter {

    /**
     * Checks if CodeUpgradeTask is not to be executed
     * @param codeUpgradeTask the {@link CodeUpgradeTask} to be checked
     * @return true if class is blacklisted and should therefore be skipped by caller.
     */
    boolean isSkipped(CodeUpgradeTask codeUpgradeTask) {
		return false;
	}
}