/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.compat.codeupgrade.annotations;

import aQute.bnd.annotation.ProviderType;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * The {@code VersionRangeFilter} defines the VersionRange for which a CodeUpgradeTask needs to be run.
 * {@code VersionRangeTaskIgnorelist} as will compare this range against the bundlelist of the source
 * instance to evaluate the need to run the {@link com.day.cq.compat.codeupgrade.CodeUpgradeTask}.
 * If the version of the linked bundle is outside of the defined range the {@link com.day.cq.compat.codeupgrade.CodeUpgradeTask}.
 * will be skipped. The VersionRange String needs to follow the syntax defined by {@link org.osgi.framework.VersionRange}
 */
@ProviderType
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.TYPE})
public @interface VersionRangeFilter {
    String bundleSymbolicName ();
    String versionRange();
}
