package com.day.cq.dam.commons.watermark;

import com.day.cq.commons.ImageHelper;
import com.day.image.Layer;

import org.apache.commons.io.IOUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.imageio.ImageIO;

import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.*;

/**
 *  A utility class with static method for performing water marking operations on a {@link WatermarkContext}
 */
public class WatermarkUtil {

    /**
     * Logger instance for this class.
     */
    private static final Logger LOG = LoggerFactory.getLogger(WatermarkUtil.class);

    /**
     * Debug marker flag
     */
    private static final boolean _debug = false;

    /**
     * Applies the watermark on top of the underlying image.<br/>
     * Before applying, it also styles the watermark considering the following:<br/>
     * <ul>
     *     <li>position     - relative to the underlying source image</li>
     *     <li>orientation  - angle of rotation as measured from the x-axis in clockwise direction</li>
     *     <li>opacity      - transparency of the watermark</li>
     * </ul>
     *
     * @throws WatermarkingException
     */
    public static void applyWatermark(WatermarkContext ctx) throws WatermarkingException {
	}

    private static void saveLayer(Layer layer) throws IOException {
	}
}
