/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.dam.scene7.api;

import java.net.URL;

import aQute.bnd.annotation.ProviderType;

/**
 * This class provides the abstractization for a Scene7 endpoint.
 */
@ProviderType
public class Scene7Endpoint implements Comparable<Scene7Endpoint> {
    public static final int DEFAULT_PORT = 80;

    private final URL apiURL;
    private final URL ipsURL;
    private final URL spsURL;
    private final URL viewerSdkURL;
    private final String apiVersion;
    private final String region;
    private final String description;
    private final URL defaultSecurePreviewURL;

    /**
     * Initializes a default {@code Scene7Endpoint}.
     * 
     * @param apiURL
     * @param ipsURL
     * @param apiVersion
     * @param region
     * @param description
     * @param defaultSecurePreviewURL
     */
    public Scene7Endpoint(final URL apiURL, final URL ipsURL, final URL spsURL,
            final String apiVersion, final String region,
            final String description, final URL defaultSecurePreviewURL) {
        this.apiURL = apiURL;
        this.ipsURL = ipsURL;
        this.spsURL = spsURL;
        this.viewerSdkURL = null;
        this.apiVersion = apiVersion;
        this.region = region;
        this.description = description;
        this.defaultSecurePreviewURL = defaultSecurePreviewURL;
    }

    /**
     * Initializes a default {@code Scene7Endpoint}.
     * 
     * @param apiURL
     * @param ipsURL
     * @param spsURL
     * @param viewerSdkURL
     * @param apiVersion
     * @param region
     * @param description
     * @param defaultSecurePreviewURL
     */
    public Scene7Endpoint(final URL apiURL, final URL ipsURL, final URL spsURL, final URL viewerSdkURL,
            final String apiVersion, final String region,
            final String description, final URL defaultSecurePreviewURL) {
        this.apiURL = apiURL;
        this.ipsURL = ipsURL;
        this.spsURL = spsURL;
        this.viewerSdkURL = viewerSdkURL;
        this.apiVersion = apiVersion;
        this.region = region;
        this.description = description;
        this.defaultSecurePreviewURL = defaultSecurePreviewURL;
    }

    /**
     * Initializes a default {@code Scene7Endpoint}.
     * 
     * @param apiURL
     * @param ipsURL
     * @param spsURL
     * @param viewerSdkURL
     * @param apiVersion
     * @param region
     * @param description
     */
    @Deprecated
    public Scene7Endpoint(final URL apiURL, final URL ipsURL, final URL spsURL,
            final URL viewerSdkURL, final String apiVersion,
            final String region, final String description) {
        this(apiURL, ipsURL, spsURL, viewerSdkURL, apiVersion, region,
                description, null);
    }

    /**
     * Initializes a default {@code Scene7Endpoint}.
     * 
     * @param apiURL
     * @param ipsURL
     * @param apiVersion
     * @param region
     * @param description
     */
    @Deprecated
    public Scene7Endpoint(final URL apiURL, final URL ipsURL, final URL spsURL,
            final String apiVersion, final String region,
            final String description) {
        this(apiURL, ipsURL, spsURL, apiVersion, region, description, null);
    }

    @Override
    public String toString() {
		return null;
	}

    public URL getApiURL() {
		return null;
	}

    public URL getIpsURL() {
		return null;
	}

    public URL getSpsURL() {
		return null;
	}

    public URL getViewerSdkURL() {
		return null;
	}

    public String getApiVersion() {
		return null;
	}

    public String getRegion() {
		return null;
	}

    public String getDescription() {
		return null;
	}

    public URL getDefaultSecurePreviewURL() {
		return null;
	}

    @Override
    public int compareTo(final Scene7Endpoint o) {
		return 0;
	}
}
