/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ************************************************************************/
package com.day.cq.dam.scene7.api.model;

import javax.annotation.Nonnull;

import com.google.common.collect.ImmutableList;

/**
 * Configuration information about a Scene7 viewer
 */
public interface Scene7ViewerConfig {

    /**
     * The type of viewer the configuration is for
     *
     * @return
     */
    @Nonnull
    String getType() {
		return null;
	}

    /**
     * The list of settings for the viewer
     *
     * @return
     */
    @Nonnull
    ImmutableList<Scene7ConfigSetting> getSettings() {
		return null;
	}
}
