/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.day.cq.mcm.campaign;

/**
 * Defines some basic property names and other stuff used by the Adobe Campaign integration.
 */
public final class Defs {

    private Defs() {
        // prevent instantiation
    }

    public static final String PN_MAPPING = "acMapping";

    public static final String PN_TEMPLATE = "acTemplateId";

    public static final String PN_RECON_KEY = "acReconciliationKey";

    public static final String PN_HOST = "apiendpoint";

    public static final String PN_USER = "username";

    public static final String PN_PASSWORD = "password";

    public static final String PN_DELIVERY = "acDelivery";

    public static final String PN_PUBLISH_STATUS = "acPublishState";

    public static final String PN_URL_PARAMETER = "urlParameter";

    public static final String PN_ALLOW_NEW_PROFILES = "acAllowNewProfiles";

    public static final String JSON_RET_DELIVERY = "deliveryName";

    public static final String RT_ENCRYPTED_PK =
            "mcm/campaign/components/form/profile/encryptedPK";

    public static final String RT_SUBSCRIPTION_FIELD =
            "mcm/campaign/components/form/subscriptions/base";

    public static final String[] BOOLEAN_FALSE_VALUES = new String[] {
            "0", "false", "off", "no"
    };

    public static final String[] BOOLEAN_TRUE_VALUES = new String[] {
            "1", "true", "on", "yes"
    };

    @Deprecated
    public static final String RT_NEWSLETTER_BASE = "mcm/campaign/components/newsletter";

    public static final String JSP_ID_PREFIX = "AdobeCampaign_Delivery_Version";

    public static final String REFTYPE_CAMPAIGN = "campaign";

    public static final String CAMPAIN_PUBLISH_TYPE = "cq:Page";


}
