/*
 * ***********************************************************************
 *
 *  ADOBE CONFIDENTIAL
 *  ___________________
 *
 *   Copyright 2012 Adobe Systems Incorporated
 *   All Rights Reserved.
 *
 *  NOTICE:  All information contained herein is, and remains
 *  the property of Adobe Systems Incorporated and its suppliers,
 *  if any.  The intellectual and technical concepts contained
 *  herein are proprietary to Adobe Systems Incorporated and its
 *  suppliers and are protected by trade secret or copyright law.
 *  Dissemination of this information or reproduction of this material
 *  is strictly forbidden unless prior written permission is obtained
 *  from Adobe Systems Incorporated.
 * ************************************************************************
 */

package com.day.cq.mcm.emailprovider.types;

/**
 * Defines interface for a subscription list on the external email provider. Getter and setter for List id and name are inherited from NamedType.
 */
public interface SubscriptionList extends NamedType {
    /**
     * This can be used as a custom parameter to pass the list description.
     */
    public static final String PARAM_DESCRIPTION = "description";
    /**
     * This can be used as a custome parameter to pass the list classification.
     */
    public static final String PARAM_CLASSIFICATION = "classification";
}
