/*******************************************************************************
 * ADOBE CONFIDENTIAL
 * __________________
 * Copyright 2015 Adobe Systems Incorporated
 * All Rights Reserved.
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ******************************************************************************/

package com.day.cq.personalization;

import java.util.List;

import aQute.bnd.annotation.ProviderType;

/**
 * A teaser meta-data object
 */
@ProviderType
public interface Teaser {

    /**
     * Returns the repository path of the teaser
     * @return a {@link String} representing the path
     */
    String getPath() {
		return null;
	}

    /**
     * Returns the name of the teaser
     * @return a {@link String} representing the name
     */
    String getName() {
		return null;
	}

    /**
     * Returns the title of the teaser
     * @return a {@link String} representing the title
     */
    String getTitle() {
		return null;
	}

    /**
     * Return the name of the campaign that contains this teaser
     * @return a {@link String} representing the name of the campaign
     */
    String getCampaignName() {
		return null;
	}

    /**
     * Returns the path of the campaign that contains this teaser
     * @return a {@link String} representing the path to the campaign
     */
    String getCampaignPath() {
		return null;
	}

    /**
     * Returns the path to the thumbnail of this teaser (the *.thumb.png selector)
     * @return a {@link String} representing the path to the thumbnail
     */
    String getThumbnailPath() {
		return null;
	}

    /**
     * Returns the unique id of the teaser.
     * @return a {@link String} representing the unique id
     */
    String getId() {
		return null;
	}

    /**
     * Returns a list of segments associated with this teaser
     * @return a {@link List} of {@link String} objects, or an empty list if the teaser has no segments
     */
    List<String> getSegments() {
		return null;
	}

    /**
     * Returns the list of tags associated to this teaser
     * @return a {@link List} of {@link TeaserTag} objects or an empty list if the teaser has no tags
     */
    List<TeaserTag> getTags() {
		return null;
	}

    /**
     * Returns the URL to the teaser
     * @return a {@link String} representing the URL
     */
    String getUrl() {
		return null;
	}
}
