/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.security;

import javax.jcr.AccessDeniedException;
import javax.jcr.Session;

/**
 * Creates a {@link UserManager UserManager} for a given
 * {@link javax.jcr.Session Session}.
 * Implementations have to return a UserManager, that respects the access rights
 * of the given Session.
 *
 * @deprecated cq 5.5 Use <code>JackrabbitSession#getUserManager()</code> instead.
 */
public interface UserManagerFactory {

    /**
     * NOTE: the Manager will be invalid if session is closed.
     *
     * @param session to access a UserManager for
     * @return the user manager
     * @throws javax.jcr.AccessDeniedException
     *          in case the session is not allowed
     *          to access a UserManager
     */
    UserManager createUserManager(Session session) throws AccessDeniedException {
		return null;
	}
}
