/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.wcm.commons;

import com.day.cq.commons.jcr.JcrUtil;
import com.day.cq.wcm.api.Page;
import com.day.cq.wcm.api.PageManager;
import com.day.cq.wcm.api.WCMException;
import com.day.text.Text;
import org.apache.commons.lang.StringUtils;
import org.apache.jackrabbit.JcrConstants;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ResourceUtil;

import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.jcr.Session;
import java.util.StringTokenizer;

import static com.day.cq.commons.jcr.JcrConstants.JCR_CONTENT;
import static com.day.cq.wcm.commons.Constants.PATH_UGC;

/**
 * Collection of utilities revolving around CQ Social Collaboration features.
 *
 * @since CQ 5.6
 */
public class UGCUtil {

    /**
     * This method maps the given <code>resource</code> to its equivalent path in /usergenerated, e.g. as the
     * relationship a page <i>/content/test</i> to its comment at <i>/content/usergenerated/content/test</i>.
     *
     * @param resource The resource to transpose to the comment's UCG path.
     * @return A <code>String</code> representing the equivalent UCG path.
     */
    public static String resourceToUGCPath(final Resource resource) {
		return null;
	}

    /**
     * This method maps the given <code>resource</code> in /content/usergenerated to its equivalent path in the normal
     * content tree, e.g. as the relationship of a comment in <i>//content/usergenerated/content/test</i> to its parent
     * resource at <i>/content/test</i>.
     *
     * @param resource The resource to transpose.
     * @return A <code>String</code> representing the equivalent normal content path.
     */
    public static String UGCToResourcePath(final Resource resource) {
		return null;
	}

    /**
     * Returns the given <code>resource</code>'s path without its potential <i>/jcr:content/...</i> suffix, thus
     * representing a page path.
     *
     * @param resource The resource to check.
     * @return A <code>String</code> representing the page path.
     */
    public static String getPagePath(final Resource resource) {
		return null;
	}

    /**
     * Gets or creates user generated content node
     *
     * @param resolver The resource resolver.
     * @param pagePath The page path.
     * @return A <code>String</code> representing the UCG path.
     * @throws WCMException If an error occurs while getting or creating user generated content node
     */
    public static String prepareUserGeneratedContent(ResourceResolver resolver, String pagePath) throws WCMException {
		return null;
	}

    /**
     * Returns the given <code>resource</code>'s name without selectors and / or file extension.
     *
     * @param resource The resource from which to retrieve its name.
     * @return A <code>String</code> representing the id.
     */
    public static String getIdFromResource(final Resource resource) {
		return null;
	}

    protected static void save(ResourceResolver resolver) throws WCMException, IllegalArgumentException {
	}

    protected static Page createPage(ResourceResolver resolver,
                                     String path,
                                     String template,
                                     String resourceTypeProp,
                                     String resourceType,
                                     String title) throws WCMException {
										return null;
									}

    protected static Page createPage(ResourceResolver resolver,
                                     String parentPath,
                                     String name,
                                     String template,
                                     String resourceTypeProp,
                                     String resourceType,
                                     String title) throws WCMException {
										return null;
									}

    protected static Node createNode(ResourceResolver resolver, String path, String nodeType) throws WCMException {
		return null;
	}

}
