/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.wcm.designimporter.api;

/**
 * Marker interface for indicating that the {@link TagHandler} handles content outside of the canvas.
 *
 * <p>
 * Tag Handlers work in a chain of responsibility with each tag handler creating a new instance of a
 * nested tag handler and delegating to it. Majority of the tag handlers don't have a standalone existence
 * and work nested within other tag handlers. The tag handlers which are capable of working stand alone need
 * to implement this interface.
 * </p>
 *
 */
public interface EntryTagHandler {

}
