/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.wcm.designimporter.parser.taghandlers;

import java.util.HashMap;
import java.util.Map;

import javax.jcr.RepositoryException;

import com.day.cq.wcm.designimporter.ErrorCodes;
import org.apache.sling.api.resource.ValueMap;
import org.apache.sling.api.wrappers.ValueMapDecorator;
import org.ccil.cowan.tagsoup.AttributesImpl;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.xml.sax.Attributes;

import com.day.cq.commons.DownloadResource;
import com.day.cq.dam.indd.PageComponent;
import com.day.cq.wcm.designimporter.DesignImportException;
import com.day.cq.wcm.designimporter.UnsupportedTagContentException;
import com.day.cq.wcm.designimporter.parser.HTMLContentType;
import com.day.cq.wcm.designimporter.util.TagUtils;

/**
 * The image component tag handler is used to translate the image component div(or an equivalent markup)
 * into a CQ image component.
 *
 * <p>
 * This tag handler is registered against the markup of type < div|span|img data-cq-component="image" >
 * (Read as a div, span, img tag with the attribute data-cq-component equal to "image"). That implies
 * this tag handler will come into action whenever the design importer framework
 * encounters an HTML tag matching the rule this handler is defined against.
 * </p>
 *
 * @see com.day.cq.wcm.designimporter.parser.taghandlers.factory.ImageComponentTagHandlerFactory
 */
public class ImageComponentTagHandler extends AbstractTagHandler {

    private Logger logger = LoggerFactory.getLogger(ImageComponentTagHandler.class);

    private String imageFileReference;

    private String alt;

    private String title;

    private String height;

    private String width;

    private String usemap;

    private String suffix;

    private String resourceType;

    @Override
    public void beginHandling(String uri, String localName, String qName, Attributes atts) throws DesignImportException {
	}

    @Override
    public void startElement(String uri, String localName, String qName, Attributes atts) throws DesignImportException {
	}

    @Override
    public void characters(char[] ch, int start, int length) throws DesignImportException {
	}

    @Override
    public void endElement(String uri, String localName, String qName) throws DesignImportException {
	}

    private String getDesignPath() {
		return null;
	}

    @Override
    public void endHandling(String uri, String localName, String qName) throws DesignImportException {
	}

    @Override
    public boolean supportsContent(HTMLContentType htmlContentType) {
		return false;
	}

    private String getNameHint() {
		return null;
	}

    @Override
    public Object getContent(HTMLContentType htmlContentType) {
		return null;
	}

    private Map<String, Object> getPropertyMap() {
		return null;
	}

    public void setResourceType(String resourceType) {
	}

}
