/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.wcm.designimporter.parser.taghandlers;

import java.util.HashMap;
import java.util.Map;

import com.day.cq.wcm.designimporter.ErrorCodes;
import com.day.cq.wcm.designimporter.util.TagUtils;
import org.apache.sling.api.resource.ValueMap;
import org.apache.sling.api.wrappers.ValueMapDecorator;
import org.ccil.cowan.tagsoup.AttributesImpl;
import org.xml.sax.Attributes;

import com.day.cq.dam.indd.PageComponent;
import com.day.cq.wcm.designimporter.DesignImportException;
import com.day.cq.wcm.designimporter.UnsupportedTagContentException;
import com.day.cq.wcm.designimporter.parser.HTMLContentType;

/**
 * The title component tag handler is used to translate the title component div(or an equivalent markup)
 * into a CQ title component.
 *
 * <p>
 * This tag handler is registered against the markup of type < div|h1-6 data-cq-component="title" >
 * (Read as a div, h1, h2,.., h6 tag with the attribute data-cq-component equal to "title"). That implies
 * this tag handler will come into action whenever the design importer framework
 * encounters an HTML tag matching the rule this handler is defined against.
 * </p>
 *
 * @see com.day.cq.wcm.designimporter.parser.taghandlers.factory.TitleComponentTagHandlerFactory
 */
public class TitleComponentTagHandler extends AbstractTagHandler {

    private String resourceType;

    private String type;

    private String suffix;

    private int stackCounter = 0;

    @Override
    public void beginHandling(String uri, String localName, String qName, Attributes atts) throws DesignImportException {
	}

    @Override
    public void startElement(String uri, String localName, String qName, Attributes atts) throws DesignImportException {
	}

    @Override
    public void characters(char[] ch, int start, int length) throws DesignImportException {
	}

    @Override
    public void endElement(String uri, String localName, String qName) throws DesignImportException {
	}

    @Override
    public void endHandling(String uri, String localName, String qName) throws DesignImportException {
	}

    @Override
    public boolean supportsContent(HTMLContentType htmlContentType) {
		return false;
	}

    private String getNameHint() {
		return null;
	}

    @Override
    public Object getContent(HTMLContentType htmlContentType) {
		return null;
	}

    public void setResourceType(String resourceType) {
	}

}
