/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.wcm.mobile.api.devicespecs;

/** Constants for DeviceSpecs capabilities names.
 *  See http://wurfl.sourceforge.net/help_doc.php for definitions
 */
public interface DeviceSpecsConstants {

    String DSPEC_SCREEN_RESOLUTION_WIDTH = "resolution_width";
    String DSPEC_SCREEN_RESOLUTION_HEIGHT = "resolution_height";

    String DSPEC_IMAGE_FORMAT_PNG = "png";
    String DSPEC_IMAGE_FORMAT_JPG = "jpg";

    String DSPEC_AJAX_SUPPORT_JAVASCRIPT = "ajax_support_javascript";

    String DSPEC_XHTML_SUPPORT_LEVEL = "xhtml_support_level";

    String DSPEC_DUAL_ORIENTATION = "dual_orientation";
    
    String DSPEC_BRAND_NAME = "brand_name";
    String DSPEC_MODEL_NAME = "model_name";
    
    String DSPEC_FALLBACK = "fall_back";
    
    /** Prefix for fake capabilities that we add for troubleshooting */
    String DSPEC_FAKE_CAP_PREFIX = "_cq:";
}
