/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.wcm.resource.details;

import com.day.cq.commons.LabeledResource;
import com.day.cq.dam.api.Asset;
import com.day.cq.dam.api.AssetReferenceResolver;
import com.day.cq.dam.api.Rendition;
import com.day.cq.dam.commons.util.DamUtil;
import com.day.cq.dam.commons.util.UIHelper;
import com.day.cq.wcm.commons.ReferenceSearch;
import com.day.image.Layer;
import com.day.text.Text;
import org.apache.commons.lang.StringUtils;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ValueMap;
import org.apache.sling.commons.json.JSONObject;

import javax.jcr.Node;
import javax.jcr.RepositoryException;
import java.io.InputStream;
import java.util.Calendar;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

/**
 * Class which gives access to some details of an asset
 */
public class AssetDetails implements ResourceDetails {

    final String ASSET_PROPERTY_METADATA = "jcr:content/metadata";
    final String ASSET_PROPERTY_COMMENTS = "jcr:content/comments";

    private Resource resource;
    private Asset asset;
    private Node assetNode;

    public AssetDetails(Resource resource) {
        if (resource == null) {
            throw new IllegalArgumentException("Resource may not be null!");
        }
        this.resource = resource;
        this.assetNode = resource.adaptTo(Node.class);
        this.asset = resource.adaptTo(Asset.class);
    }

    public Node getAssetNode() {
		return null;
	}

    public Asset getAsset() {
		return null;
	}

    /**
     * Get name
     */
    public String getName() throws RepositoryException {
		return null;
	}

    /**
     * Get last modified
     *
     * @return
     */
    public long getLastModified() throws RepositoryException {
		return 0L;
	}

    /**
     * Get mime type of asset
     *
     * @return mime type of asset
     * @throws javax.jcr.RepositoryException
     */
    public String getMimeType() {
		return null;
	}

    /**
     * Count all asset references
     *
     * @param customResolver
     * @return
     * @throws RepositoryException
     */
    public int getReferencesSize(AssetReferenceResolver customResolver) throws RepositoryException {
		return 0;
	}

    /**
     * Get number of comments
     *
     * @return number of comments
     * @throws javax.jcr.RepositoryException
     */
    public int getCommentsSize() throws RepositoryException {
		return 0;
	}

    /**
     * Get URL for thumbnail
     *
     * @return
     */
    public String getThumbnailUrl() {
		return null;
	}

    /**
     * Get width of the asset
     *
     * @return width of asset
     * @throws javax.jcr.RepositoryException
     */
    public long getWidth() throws RepositoryException {
		return 0L;
	}

    /**
     * Get height of the asset
     *
     * @return height of asset
     * @throws javax.jcr.RepositoryException
     */
    public long getHeight() throws RepositoryException {
		return 0L;
	}

    /**
     * Get size of asset
     *
     * @return size of asset
     * @throws javax.jcr.RepositoryException
     */
    public String getSize() {
		return null;
	}

    /**
     * Get resolution of asset
     *
     * @return resolution of asset
     * @throws javax.jcr.RepositoryException
     */
    public String getResolution() throws RepositoryException {
		return null;
	}

    /**
     * Get description of the asset
     *
     * @return description
     */
    public String getDescription() throws RepositoryException {
		return null;
	}

    public String getParamJSON() throws RepositoryException {
		return null;
	}
}
