/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.wcm.tags;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.el.ELException;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspTagException;

/**
 * <code>AbstractParamTag</code> is a base class for tags that modify a
 * {@link RequestURLTag}.
 */
abstract class AbstractParamTag extends TagSupport {

    private static final long serialVersionUID = -689412859703401766L;

    /**
     * The name of the parameter.
     */
    private String name;

    /**
     * The value for the parameter.
     */
    private String value;

    /**
     * Default constructor.
     */
    public AbstractParamTag() {
        super();
        init();
    }

    public final int doEndTag() throws JspException {
		return 0;
	}

    /**
     * A concrete implementation will modify the passed <code>urlTag</code> in
     * a implementation specific way.
     *
     * @param urlTag the request URL tag that will be modified.
     */
    protected abstract void applyTo(RequestURLTag urlTag) {
	}

    /**
     * Do some clean up.
     */
    public void release() {
	}

    //--------------------------------< properties >----------------------------

    public String getName() {
		return null;
	}

    public void setName(String name) throws ELException {
	}

    public String getValue() {
		return null;
	}

    public void setValue(String value) throws ELException {
	}

    //-----------------------------< internal >---------------------------------

    private void init() {
	}

    /**
     * Evaluates the given expression.
     *
     * @param expression the expression.
     * @param clazz the expected type of the return value.
     * @return the evaluated expression.
     * @throws ELException if an error occurs while evaluating the expression.
     */
    @SuppressWarnings({"unchecked"})
    private <T> T evaluate(String expression, Class<T> clazz)
            throws ELException {
				return null;
			}
}
