/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.workflow.exec;

import com.day.cq.workflow.WorkflowSession;
import com.day.cq.workflow.model.WorkflowNode;

/**
 * <code>JavaProcess</code> is the interface for is used for automatic workflow
 * steps implemented in Java. Classes implementing this interface define Java
 * based processes that can be attached to a {@link WorkflowNode} and executed
 * by the workflow engine.
 * 
 * @deprecated Use {@link WorkflowProcess} instead.
 * 
 * @see WorkflowProcess
 */
public interface JavaProcess {
    /**
     * Executes a new Java process with the given <code>{@link WorkItem}</code>
     * and <code>{@link WorkflowSession}</code>.
     * 
     * @param item
     *            The <code>{@link WorkItem}</code> that defines the newly
     *            started <code>JavaProcess</code>.
     * @param session
     *            The <code>{@link WorkflowSession}</code> that is used for
     *            starting the <code>JavaProcess</code>.
     * @throws Exception
     *             Thrown in case something goes wrong during execution.
     * @deprecated
     */
    void execute(WorkItem item, WorkflowSession session) throws Exception {
	}
}
