/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.oak.plugins.index.aggregate;

import java.util.Collection;
import java.util.HashMap;
import java.util.List;

import javax.annotation.CheckForNull;

import org.apache.jackrabbit.oak.spi.query.Filter;
import org.apache.jackrabbit.oak.spi.query.Filter.PropertyRestriction;
import org.apache.jackrabbit.oak.spi.query.QueryIndex.IndexPlan;
import org.apache.jackrabbit.oak.spi.query.QueryIndex.OrderEntry;
import org.apache.jackrabbit.oak.spi.state.NodeState;

/**
 * An index plan for multiple query indexes.
 */
public class AggregateIndexPlan implements IndexPlan {
    
    private Filter filter;
    private boolean pathWithoutPlan;
    
    /**
     * The map of terms to plans.
     */
    private final HashMap<String, IndexPlan> basePlans = new HashMap<String, IndexPlan>();
    
    AggregateIndexPlan(Filter filter) {
        this.filter = filter;
    }
    
    void setPlan(String path, List<IndexPlan> plans) {
	}
    
    boolean containsPathWithoutPlan() {
		return false;
	}
    
    IndexPlan getPlan(String path) {
		return null;
	}
    
    Collection<IndexPlan> getPlans() {
		return null;
	}

    @Override
    public double getCostPerExecution() {
		return 0.0d;
	}

    @Override
    public double getCostPerEntry() {
		return 0.0d;
	}

    @Override
    public long getEstimatedEntryCount() {
		return 0L;
	}

    @Override
    public Filter getFilter() {
		return null;
	}

    @Override
    public void setFilter(Filter filter) {
	}

    /**
     * Whether any base plan is delayed.
     * 
     * @return true if yes
     */
    @Override
    public boolean isDelayed() {
		return false;
	}

    /**
     * Whether any base plan is a full text index.
     * 
     * @return true if yes
     */
    @Override
    public boolean isFulltextIndex() {
		return false;
	}

    /**
     * Whether all base plan include node data.
     * 
     * @return true if yes
     */
    @Override
    public boolean includesNodeData() {
		return false;
	}

    /**
     * An aggregated query can not sort, as it gets results from a number of
     * indexes.
     * 
     * @return null
     */
    @Override
    public List<OrderEntry> getSortOrder() {
		return null;
	}

    // the following methods probably shouldn't be in the IndexPlan interface
    // as they are only used locally (in the ordered index, or in the lucene index)
    
    @Override
    @CheckForNull
    public PropertyRestriction getPropertyRestriction() {
		return null;
	}

    @Override
    public IndexPlan copy() {
		return null;
	}
    
    @Override
    public NodeState getDefinition() {
		return null;
	}

    @Override
    public String getPathPrefix() {
		return null;
	}

    @Override
    @CheckForNull
    public Object getAttribute(String name) {
		return null;
	}

    @Override
    public String getPlanName() {
		return null;
	}

}
