/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.apache.jackrabbit.oak.plugins.index.lucene;

import javax.management.openmbean.TabularData;

import aQute.bnd.annotation.ProviderType;

@SuppressWarnings("UnusedDeclaration")
@ProviderType
public interface CopyOnReadStatsMBean {
    String TYPE = "IndexCopierStats";

    TabularData getIndexPathMapping() {
		return null;
	}

    boolean isPrefetchEnabled() {
		return false;
	}

    int getReaderLocalReadCount() {
		return 0;
	}

    int getReaderRemoteReadCount() {
		return 0;
	}

    int getWriterLocalReadCount() {
		return 0;
	}

    int getWriterRemoteReadCount() {
		return 0;
	}

    int getScheduledForCopyCount() {
		return 0;
	}

    int getCopyInProgressCount() {
		return 0;
	}

    int getMaxCopyInProgressCount() {
		return 0;
	}

    int getMaxScheduledForCopyCount() {
		return 0;
	}

    String getCopyInProgressSize() {
		return null;
	}

    String[] getCopyInProgressDetails() {
		return null;
	}

    String getDownloadSize() {
		return null;
	}

    long getDownloadTime() {
		return 0L;
	}

    int getDownloadCount() {
		return 0;
	}

    String getUploadSize() {
		return null;
	}

    long getUploadTime() {
		return 0L;
	}

    int getUploadCount() {
		return 0;
	}

    String getLocalIndexSize() {
		return null;
	}

    String[] getGarbageDetails() {
		return null;
	}

    String getGarbageSize() {
		return null;
	}

    int getDeletedFilesCount() {
		return 0;
	}

    String getGarbageCollectedSize() {
		return null;
	}

    String getSkippedFromUploadSize() {
		return null;
	}
}
