/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.jackrabbit.oak.plugins.observation;

import java.util.Set;

import javax.annotation.Nullable;

import com.google.common.collect.Sets;
import org.apache.jackrabbit.oak.commons.PathUtils;

/**
 * Builder of a ChangeSet - only used by ChangeCollectorProvider (and tests..)
 */
public class ChangeSetBuilder {

    private final int maxItems;
    private int maxPathDepth;
    private final Set<String> parentPaths = Sets.newHashSet();
    private final Set<String> parentNodeNames = Sets.newHashSet();
    private final Set<String> parentNodeTypes = Sets.newHashSet();
    private final Set<String> propertyNames = Sets.newHashSet();
    private final Set<String> allNodeTypes = Sets.newHashSet();

    private boolean parentPathOverflow;
    private boolean parentNodeNameOverflow;
    private boolean parentNodeTypeOverflow;
    private boolean propertyNameOverflow;
    private boolean allNodeTypeOverflow;

    public ChangeSetBuilder(int maxItems, int maxPathDepth) {
        this.maxItems = maxItems;
        this.maxPathDepth = maxPathDepth;
    }

    @Override
    public String toString() {
		return null;
	}

    public boolean isParentPathOverflown() {
		return false;
	}

    public ChangeSetBuilder addParentPath(String path){
		return null;
	}

    public boolean isParentNodeNameOverflown() {
		return false;
	}

    public ChangeSetBuilder addParentNodeName(String parentNodeName) {
		return null;
	}

    public boolean isParentNodeTypeOverflown() {
		return false;
	}

    public ChangeSetBuilder addParentNodeTypes(Iterable<String> nodeTypes){
		return null;
	}

    public ChangeSetBuilder addParentNodeType(String parentNodeType) {
		return null;
	}

    public boolean isPropertyNameOverflown() {
		return false;
	}

    public ChangeSetBuilder addPropertyName(String propertyName) {
		return null;
	}
    public boolean isAllNodeTypeOverflown() {
		return false;
	}

    public ChangeSetBuilder addNodeTypes(Iterable<String> nodeTypes){
		return null;
	}

    public ChangeSetBuilder addNodeType(String nodeType) {
		return null;
	}

    public int getMaxPrefilterPathDepth() {
		return 0;
	}

    public ChangeSetBuilder add(@Nullable ChangeSet cs){
		return null;
	}

    public ChangeSet build() {
		return null;
	}

    private void addPathFromChangeSet(ChangeSet cs) {
	}

    private static String getPathWithMaxDepth(String path, int maxDepth){
		return null;
	}

    /**
     * Add data to dataSet if dataSet size is less than maxSize.
     *
     * @return true if dataSet size is at maxSize i.e. overflow condition reached
     */
    private static boolean addAndCheckOverflow(Set<String> dataSet, String data, int maxSize, boolean overflow) {
		return false;
	}

}
