/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.jackrabbit.oak.query.fulltext;

import java.text.ParseException;
import java.util.ArrayList;

import org.apache.jackrabbit.oak.query.ast.FullTextSearchImpl;


/**
 * A parser for fulltext condition literals. The grammar is defined in the
 * <a href="http://www.day.com/specs/jcr/2.0/6_Query.html#6.7.19">
 * JCR 2.0 specification, 6.7.19 FullTextSearch</a>,
 * as follows (a bit simplified):
 * <pre>
 * FullTextSearchLiteral ::= Disjunct {' OR ' Disjunct}
 * Disjunct ::= Term {' ' Term}
 * Term ::= ['-'] SimpleTerm
 * SimpleTerm ::= Word | '"' Word {' ' Word} '"'
 * </pre>
 */
public class FullTextParser {

    private String propertyName;
    private String text;
    private int parseIndex;

    public static FullTextExpression parse(String propertyName, String text) throws ParseException {
		return null;
	}

    FullTextExpression parseOr() throws ParseException {
		return null;
	}

    FullTextExpression parseAnd() throws ParseException {
		return null;
	}

    FullTextExpression parseTerm() throws ParseException {
		return null;
	}

    private ParseException getSyntaxError(String expected) {
		return null;
	}

}
