/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.apache.jackrabbit.oak.spi.blob.split;

import java.io.IOException;
import java.io.InputStream;

import org.apache.jackrabbit.oak.spi.blob.BlobOptions;
import org.apache.jackrabbit.oak.spi.blob.BlobStore;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class DefaultSplitBlobStore implements SplitBlobStore {

    private static final Logger log = LoggerFactory.getLogger(BlobIdSet.class);

    private static final String OLD_BLOBSTORE_PREFIX = "o_";

    private static final String NEW_BLOBSTORE_PREFIX = "n_";

    private final BlobStore oldBlobStore;

    private final BlobStore newBlobStore;

    private final BlobIdSet migratedBlobs;

    public DefaultSplitBlobStore(String repositoryDir, BlobStore oldBlobStore, BlobStore newBlobStore) {
        this.oldBlobStore = oldBlobStore;
        this.newBlobStore = newBlobStore;
        this.migratedBlobs = new BlobIdSet(repositoryDir, "migrated_blobs.txt");
    }

    public boolean isMigrated(String blobId) throws IOException {
		return false;
	}

    @Override
    public String writeBlob(InputStream in) throws IOException {
		return null;
	}

    /**
     * Ignores the options provided and delegates to {@link #writeBlob(InputStream)}.
     *
     * @param in the input stream to write
     * @param options the options to use
     * @return
     * @throws IOException
     */
    @Override
    public String writeBlob(InputStream in, BlobOptions options) throws IOException {
		return null;
	}

    @Override
    public int readBlob(String blobId, long pos, byte[] buff, int off, int length) throws IOException {
		return 0;
	}

    @Override
    public long getBlobLength(String blobId) throws IOException {
		return 0L;
	}

    @Override
    public InputStream getInputStream(String blobId) throws IOException {
		return null;
	}

    @Override
    public String getBlobId(String reference) {
		return null;
	}

    @Override
    public String getReference(String blobId) {
		return null;
	}

    private BlobStore chooseBlobStoreByBlobId(String blobId) throws IOException {
		return null;
	}

    @Override
    public String toString() {
		return null;
	}
}
