/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.jackrabbit.oak.spi.query;

import static com.google.common.collect.Iterables.contains;

import java.math.BigDecimal;
import java.net.URI;

import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import javax.jcr.PropertyType;

import org.apache.jackrabbit.oak.api.Blob;
import org.apache.jackrabbit.oak.api.PropertyState;
import org.apache.jackrabbit.oak.api.PropertyValue;
import org.apache.jackrabbit.oak.api.Type;
import org.apache.jackrabbit.oak.namepath.NamePathMapper;
import org.apache.jackrabbit.oak.plugins.memory.BinaryPropertyState;
import org.apache.jackrabbit.oak.plugins.memory.BooleanPropertyState;
import org.apache.jackrabbit.oak.plugins.memory.DecimalPropertyState;
import org.apache.jackrabbit.oak.plugins.memory.DoublePropertyState;
import org.apache.jackrabbit.oak.plugins.memory.GenericPropertyState;
import org.apache.jackrabbit.oak.plugins.memory.LongPropertyState;
import org.apache.jackrabbit.oak.plugins.memory.MultiGenericPropertyState;
import org.apache.jackrabbit.oak.plugins.memory.MultiStringPropertyState;
import org.apache.jackrabbit.oak.plugins.memory.StringPropertyState;

/**
 * Utility class for creating {@link PropertyValue} instances.
 */
public final class PropertyValues {

    private PropertyValues() {
    }

    @CheckForNull
    public static PropertyValue create(@CheckForNull PropertyState property) {
		return null;
	}

    @Nonnull
    private static PropertyValue newValue(@Nonnull PropertyState property) {
		return null;
	}

    @CheckForNull
    public static PropertyState create(@CheckForNull PropertyValue value) {
		return null;
	}

    @Nonnull
    public static PropertyValue newString(@Nonnull String value) {
		return null;
	}

    @Nonnull
    public static PropertyValue newString(@Nonnull Iterable<String> value) {
		return null;
	}

    @Nonnull
    public static PropertyValue newLong(@Nonnull Long value) {
		return null;
	}

    @Nonnull
    public static PropertyValue newDouble(@Nonnull Double value) {
		return null;
	}

    @Nonnull
    public static PropertyValue newDecimal(@Nonnull BigDecimal value) {
		return null;
	}

    @Nonnull
    public static PropertyValue newBoolean(boolean value) {
		return null;
	}

    @Nonnull
    public static PropertyValue newDate(@Nonnull String value) {
		return null;
	}

    @Nonnull
    public static PropertyValue newName(@Nonnull String value) {
		return null;
	}

    @Nonnull
    public static PropertyValue newName(@Nonnull Iterable<String> value) {
		return null;
	}

    @Nonnull
    public static PropertyValue newPath(@Nonnull String value) {
		return null;
	}

    @Nonnull
    public static PropertyValue newReference(@Nonnull String value) {
		return null;
	}

    @Nonnull
    public static PropertyValue newWeakReference(@Nonnull String value) {
		return null;
	}

    @Nonnull
    public static PropertyValue newUri(@Nonnull String value) {
		return null;
	}

    @Nonnull
    public static PropertyValue newBinary(@Nonnull byte[] value) {
		return null;
	}
    
    @Nonnull
    public static PropertyValue newBinary(@Nonnull Blob value) {
		return null;
	}

    // --

    public static boolean match(@Nonnull PropertyValue p1, @Nonnull PropertyState p2) {
		return false;
	}

    public static boolean match(@Nonnull PropertyState p1, @Nonnull PropertyValue p2) {
		return false;
	}

    public static boolean match(@Nonnull PropertyValue p1, @Nonnull PropertyValue p2) {
		return false;
	}

    public static boolean notMatch(@Nonnull PropertyValue p1, @Nonnull PropertyValue p2) {
		return false;
	}

    // --

    /**
     * Converts the given value to a value of the specified target type. The
     * conversion is performed according to the rules described in
     * "3.6.4 Property Type Conversion" in the JCR 2.0 specification.
     * 
     * @param value the value to convert
     * @param targetType the target property type 
     * @param mapper the name mapper or {@code null} if no name/path mapping is required.
     * @return the converted value
     * @throws IllegalArgumentException if mapping is illegal
     */
    public static PropertyValue convert(@Nonnull PropertyValue value, int targetType, @Nullable NamePathMapper mapper) {
		return null;
	}
    
    public static boolean canConvert(int sourceType, int targetType) {
		return false;
	}

    public static String getOakPath(@Nonnull String jcrPath, @CheckForNull NamePathMapper mapper) {
		return null;
	}

}
