/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.spi.commons.logging;

import javax.jcr.RepositoryException;

import org.apache.jackrabbit.spi.Batch;
import org.apache.jackrabbit.spi.ItemId;
import org.apache.jackrabbit.spi.Name;
import org.apache.jackrabbit.spi.NodeId;
import org.apache.jackrabbit.spi.PropertyId;
import org.apache.jackrabbit.spi.QValue;
import org.apache.jackrabbit.spi.Tree;

/**
 * Log wrapper for a {@link Batch}.
 */
public class BatchLogger extends AbstractLogger implements Batch {
    private final Batch batch;

    /**
     * Create a new instance for the given <code>batch</code> which uses
     * <code>writer</code> for persisting log messages.
     * @param batch
     * @param writer
     */
    public BatchLogger(Batch batch, LogWriter writer) {
        super(writer);
        this.batch = batch;
    }

    /**
     * @return  the wrapped Batch
     */
    public Batch getBatch() {
		return null;
	}

    // -----------------------------------------------------< Batch >---

    public void addNode(final NodeId parentId, final Name nodeName, final Name nodetypeName, final String uuid)
            throws RepositoryException {
			}

    public void addProperty(final NodeId parentId, final Name propertyName, final QValue value)
            throws RepositoryException {
			}

    public void addProperty(final NodeId parentId, final Name propertyName, final QValue[] values)
            throws RepositoryException {
			}

    public void setValue(final PropertyId propertyId, final QValue value) throws RepositoryException {
	}

    public void setValue(final PropertyId propertyId, final QValue[] values) throws RepositoryException {
	}

    public void remove(final ItemId itemId) throws RepositoryException {
	}

    public void reorderNodes(final NodeId parentId, final NodeId srcNodeId, final NodeId beforeNodeId)
            throws RepositoryException {
			}

    public void setMixins(final NodeId nodeId, final Name[] mixinNodeTypeNames) throws RepositoryException {
	}

    public void setPrimaryType(final NodeId nodeId, final Name primaryNodeTypeName) throws RepositoryException {
	}

    public void move(final NodeId srcNodeId, final NodeId destParentNodeId, final Name destName)
            throws RepositoryException {
			}

    @Override
    public void  setTree(final NodeId parentId, final Tree contentTree)
            throws RepositoryException {
			}
}
